class TObject
{

};

class TAirport 
{

};

class TCargo : public TObject
{

};


class TAirPlane : public TObject
{

};

struct TIn {
    TCargo m_cargo;
    TAirPlane m_airplane;
};

struct TAt {
    TObject m_cargo;
    TAirport m_airport;
};

struct TCounter 
{
    int m_count;
};

const TAirport TestAirpot;

createTable<TIn>();
createTable<TAt>();
createTable<TCounter>();

void load(TCargo c, TAirport airport, TAirPlane p)
{
   assert(exists(TAt(c, airport)));
   assert(exists(TAt(p, airport)));
   remove(TAt(c, airport));
   insert(TIn(c, p));
}

void unload(TCargo c, TAirport airport, TAirPlane p)
{
   assert(exists(TIn(c, p)));
   assert(exists(TAt(p, airport)));
   remove(TIn(c, p));
   insert(TAt(c, airport));
}

int addone(int one) {
    return one+1;
    //return 4;
}

void fly(TAirPlane p, TAirport oldairport, TAirport newairpot, int value)
{
   

   assert(exists(TAt(p, oldairport)));
   assert(exists(TCounter(value)));
   int newvalue = addone(value);

   if (newvalue < 10) {
      remove(TAt(p, oldairport));
      insert(TAt(p, newairpot));

   }
   remove(TCounter(value));
   insert(TCounter(newvalue));
}

registerAction<load>();
registerAction<unload>();
registerAction<fly>();


int main()
{
   const TAirport JFK;
   const TAirport SFO;
   const TAirPlane p1;
   const TCargo c1;
   println("Creating the planning instance"); 
   println("------------------------------");   
   insert(TAt(c1, SFO));
   insert(TAt(p1, SFO));
   insert(TCounter(0));
   goal(TAt(c1, JFK));
   return 0;
}
