#ifndef __INVALIDCONTROL__
#define __INVALIDCONTROL__

#include "Uti3DCore.h"
#include <set>
#include "UtiString.h"
#include "utilists.h"

class CInvalidObject : public ReferenceUtiOB
{
protected:
  CReferenceList<CInvalidObject> m_sourceinterest;
  std::set<CInvalidObject*> m_targetinterest;
public:
  bool m_abort;
  bool m_allowinvalidate;
  bool m_donotdeleteuninterested;
  CUtiString m_sourceobj;
  ReferenceUtiOB* m_obj;
public:
  CInvalidObject(const CUtiString& source, ReferenceUtiOB* obj);
  ~CInvalidObject();
  virtual void setObj(ReferenceUtiOB* obj);
  virtual void increaseInterest(CInvalidObject* obj);
  virtual void decreaseInterest(CInvalidObject* obj);
  virtual void doAbort();
  virtual void clear();
  virtual void resetAbort();
  virtual void addDepend(CInvalidObject* depend);
  virtual int getDependCount();
  virtual int getInterestCount();
};

#endif
