#ifndef LISPNAMES_H
#define LISPNAMES_H

enum TLispBaseType {LIST_BASE_ELEMENT=2
#define CREATE_LISP_NAME(a, b) \
       , LISP_ ## a

#define CREATE_LISP_NAME_P0(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P1(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P2(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P3(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P0_REST(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P1_REST(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P2_REST(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P3_REST(a, b) CREATE_LISP_NAME(a,b)


#define CREATE_LISP_NAME_P0_KEY(a, b, key1) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P1_KEY(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P2_KEY(a, b) CREATE_LISP_NAME(a,b)
#define CREATE_LISP_NAME_P3_KEY(a, b) CREATE_LISP_NAME(a,b)

                    CREATE_LISP_NAME_P0_REST(list, "list")
                    CREATE_LISP_NAME_P0_REST(append, "append")
                    CREATE_LISP_NAME_P2_KEY(adjoin, "adjoin")
                    CREATE_LISP_NAME_P1(reverse, "reverse")
                    CREATE_LISP_NAME_P1(eval, "eval")
                    CREATE_LISP_NAME_P2_KEY(sort, "sort")
                    CREATE_LISP_NAME_P3_KEY(substitute, "substitute")
                    CREATE_LISP_NAME_P1(length, "length")
                    CREATE_LISP_NAME_P1(evenp, "evenp")
                    CREATE_LISP_NAME_P1(oddp, "oddp")
                    CREATE_LISP_NAME_P2_KEY(count, "count")
                    CREATE_LISP_NAME_P2_KEY(find, "find")
                    CREATE_LISP_NAME_P2_KEY(position, "position")
                    CREATE_LISP_NAME_P1(first, "first")
                    CREATE_LISP_NAME_P1(second, "second")
                    CREATE_LISP_NAME_P1(third, "third")
                    CREATE_LISP_NAME_P1(last, "last")
                    CREATE_LISP_NAME_P1(butlast, "butlast")
                    CREATE_LISP_NAME_P2(nth, "nth")
                    CREATE_LISP_NAME_P2(nthcdr, "nthcdr")
                    CREATE_LISP_NAME_P2_REST(subseq, "subseq")
                    CREATE_LISP_NAME_P2_KEY(remove, "remove")
                    CREATE_LISP_NAME_P2(push, "push")
                    CREATE_LISP_NAME_P1(pop, "pop")
                    CREATE_LISP_NAME(globals, "globals")
                    CREATE_LISP_NAME_P2_KEY(member, "member")
                    CREATE_LISP_NAME_P2(pushnew, "pushnew")
                    CREATE_LISP_NAME_P2_KEY(l_union, "union")
                    CREATE_LISP_NAME_P2_KEY(intersection, "intersection")
                    CREATE_LISP_NAME_P2_KEY(set_difference, "set-difference")
                    CREATE_LISP_NAME_P3(l_if, "if")
                    CREATE_LISP_NAME_P1_REST(when, "when")
                    CREATE_LISP_NAME_P0_REST(cond, "cond")
                    CREATE_LISP_NAME(l_case, "case")
                    CREATE_LISP_NAME_P2(cons, "cons")
                    CREATE_LISP_NAME(rest, "rest")
                    CREATE_LISP_NAME_P1(car, "car")
                    CREATE_LISP_NAME_P1(cdr, "cdr")
                    CREATE_LISP_NAME(mapc, "mapc")
                    CREATE_LISP_NAME(otherwise, "otherwise")
                    CREATE_LISP_NAME(print, "print")
                    CREATE_LISP_NAME_P0(t, "t")
                    CREATE_LISP_NAME(l_do, "do")
                    CREATE_LISP_NAME(l_return, "return")
                    CREATE_LISP_NAME(quote, "quote")
                    CREATE_LISP_NAME_P0(nil, "nil")
                    CREATE_LISP_NAME_P1(l_not, "not")
                    CREATE_LISP_NAME_P1(inc_one, "1+")
                    CREATE_LISP_NAME_P1(dec_one, "1-")
                    CREATE_LISP_NAME_P2(less, "<")
                    CREATE_LISP_NAME_P2(eless, "<=")
                    CREATE_LISP_NAME_P2(greater, ">")
                    CREATE_LISP_NAME_P2(egreater, ">=")
                    CREATE_LISP_NAME_P2(equal_numeric, "=")
                    CREATE_LISP_NAME_P2(dotimes, "dotimes")
                  CREATE_LISP_NAME(assoc, "assoc")
                    CREATE_LISP_NAME(dolist, "dolist")
                    CREATE_LISP_NAME(ash, "ash")
                    CREATE_LISP_NAME_P0_REST(progn, "progn")
                    CREATE_LISP_NAME_P0_REST(block, "block")
                    CREATE_LISP_NAME(head, "head")
                    CREATE_LISP_NAME_P2(setf, "setf")
                    CREATE_LISP_NAME_P2(equal, "equal")
                    CREATE_LISP_NAME_P0_REST(let, "let")
                    CREATE_LISP_NAME_P2(eql, "eql")
                    CREATE_LISP_NAME_P2(let_star, "let*")
                    CREATE_LISP_NAME_P1_REST(plus, "+")
                    CREATE_LISP_NAME_P1_REST(minus, "-")
                    CREATE_LISP_NAME_P1_REST(mul, "*")
                    CREATE_LISP_NAME_P1_REST(div, "/")
                    CREATE_LISP_NAME_P2_REST(defparameter, "defparameter")
                    CREATE_LISP_NAME_P2_REST(defconstant, "defconstant")
                    CREATE_LISP_NAME_P2_REST(defun, "defun")
                    CREATE_LISP_NAME_P1_REST(lambda, "lambda")
                    CREATE_LISP_NAME_P1_REST(apply, "apply")
                    CREATE_LISP_NAME_P1_REST(funcall, "funcall")
                    CREATE_LISP_NAME(mapcar, "mapcar")
                    CREATE_LISP_NAME(maplist, "maplist")
                    CREATE_LISP_NAME(values, "values")
                    CREATE_LISP_NAME_P0_REST(mutliple_value_bind, "multiple-value-bind")
                    CREATE_LISP_NAME_P0_REST(mutliple_value_call, "multiple-value-call")
                    CREATE_LISP_NAME_P2(incf, "incf")
                    CREATE_LISP_NAME_P2(decf, "decf")
                    CREATE_LISP_NAME_P1(abs, "abs")
                    CREATE_LISP_NAME_P2(mod, "mod")
                    CREATE_LISP_NAME_P1_REST(max, "max")
                    CREATE_LISP_NAME_P1_REST(min, "min")
                    CREATE_LISP_NAME_P2(expt, "expt")
                    CREATE_LISP_NAME_P1(float, "float")
                    CREATE_LISP_NAME_P1(numerator, "numerator")
                    CREATE_LISP_NAME_P1(denominator, "denominator")
                    CREATE_LISP_NAME_P1(round, "round")
                    CREATE_LISP_NAME_P1(floor, "floor")
                    CREATE_LISP_NAME_P1(ceiling, "ceiling")
                    CREATE_LISP_NAME_P1(truncate, "truncate")
                    CREATE_LISP_NAME_P1(random, "random")
                    CREATE_LISP_NAME_P1(sin, "sin")
                    CREATE_LISP_NAME_P1(cos, "cos")
                    CREATE_LISP_NAME_P1(tan, "tan")
                    CREATE_LISP_NAME_P1(asin, "asin")
                    CREATE_LISP_NAME_P1(acos, "acos")
                    CREATE_LISP_NAME_P1(atan, "atan")
                    CREATE_LISP_NAME_P1(sinh, "sinh")
                    CREATE_LISP_NAME_P1(cosh, "cosh")
                    CREATE_LISP_NAME_P1(tanh, "tanh")
                    CREATE_LISP_NAME_P1(asinh, "asinh")
                    CREATE_LISP_NAME_P1(acosh, "acosh")
                    CREATE_LISP_NAME_P1(atanh, "atanh")
                    CREATE_LISP_NAME_P2(typep, "typep")
                    CREATE_LISP_NAME_P2_REST(every, "every")
                    CREATE_LISP_NAME_P2_REST(some, "some")



                    CREATE_LISP_NAME_P1(null, "null")
                    CREATE_LISP_NAME_P1(listp, "listp")
                    CREATE_LISP_NAME_P1(zerop, "zerop")
                    CREATE_LISP_NAME_P1(plusp, "plusp")
                    CREATE_LISP_NAME_P1(minusp, "minusp")
                    CREATE_LISP_NAME_P1(upper_case_p, "upper-case-p")
                    CREATE_LISP_NAME_P1(lower_case_, "lower-case-p")
                    CREATE_LISP_NAME_P1(numberp, "numberp")
                    CREATE_LISP_NAME_P1(floatp, "floatp")
                    CREATE_LISP_NAME_P1(integerp, "integerp")
                    CREATE_LISP_NAME_P1(graphic_char_p, "graphic-char-p")
                    CREATE_LISP_NAME_P1(alphanumericp, "alphanumericp")
                    CREATE_LISP_NAME_P1(alpha_char_p, "alpha-char-p")
                    CREATE_LISP_NAME(make_array, "make-array")
                    CREATE_LISP_NAME(aref, "aref")
                    CREATE_LISP_NAME(svref, "svref")
                    CREATE_LISP_NAME(vector, "vector")
                    CREATE_LISP_NAME(defstruct, "defstruct")
                    CREATE_LISP_NAME(format, "format")
                    CREATE_LISP_NAME_P1_REST(concatenate, "concatenate")
                    CREATE_LISP_NAME(char, "char")
                    CREATE_LISP_NAME(string_capitalize, "string-capitalize")
                    CREATE_LISP_NAME(string_upcase, "string-upcase")
                    CREATE_LISP_NAME(string_downcase, "string-downcase")
                    CREATE_LISP_NAME(remove_duplicates, "remove-duplicates")
                    CREATE_LISP_NAME(read, "read")
                    CREATE_LISP_NAME(read_line, "read-line")
                    CREATE_LISP_NAME(read_from_string, "read-from-string")
                    CREATE_LISP_NAME(defmacro, "defmacro")
                    CREATE_LISP_NAME(macroexpand, "macroexpand")
                    CREATE_LISP_NAME(nthmost, "nthmost")
                    CREATE_LISP_NAME(starts_with, "starts-with")
                    CREATE_LISP_NAME(rotate_left, "rotate-left")
                    CREATE_LISP_NAME(rotate_right, "rotate-right")
                    CREATE_LISP_NAME(insert_between, "insert-between")
                    CREATE_LISP_NAME(permutations, "permutations")
                    CREATE_LISP_NAME(terpri, "terpri")
                    CREATE_LISP_NAME_P1_REST(l_and, "and")
                    CREATE_LISP_NAME_P1_REST(l_or, "or")
                    CREATE_LISP_NAME_P2(defvar, "defvar")
                    CREATE_LISP_NAME_P1_REST(unless, "unless")
                    CREATE_LISP_NAME(l_string, "string")
                    CREATE_LISP_NAME_P2_KEY(string_equal, "string=")
                    CREATE_LISP_NAME_P2_KEY(string_less, "string<")
                    CREATE_LISP_NAME_P2_KEY(string_greater, "string>")
                    CREATE_LISP_NAME_P2_KEY(string_eless, "string<=")
                    CREATE_LISP_NAME_P2_KEY(string_egreater, "string>=")
    CREATE_LISP_NAME_P1(caaar, "caaar")
    CREATE_LISP_NAME_P1(caadr, "caadr")
    CREATE_LISP_NAME_P1(caar, "caar")
    CREATE_LISP_NAME_P1(cadar, "cadar")
    CREATE_LISP_NAME_P1(caddr, "caddr")
    CREATE_LISP_NAME_P1(cadr, "cadr")
    CREATE_LISP_NAME_P1(cdaar, "cdaar")
    CREATE_LISP_NAME_P1(cdadr, "cdadr")
    CREATE_LISP_NAME_P1(cdar, "cdar")
    CREATE_LISP_NAME_P1(cddar, "cddar")
    CREATE_LISP_NAME_P1(cdddr, "cdddr")
    CREATE_LISP_NAME_P1(cddr, "cddr")
                    CREATE_LISP_NAME(d_key, ":key")
                    CREATE_LISP_NAME(d_test, ":test")
                    CREATE_LISP_NAME(d_test_not, ":test-not")
                    CREATE_LISP_NAME(d_from_end, ":from-end")
                    CREATE_LISP_NAME(d_start, ":start")
                    CREATE_LISP_NAME(d_end, ":end")
                    CREATE_LISP_NAME(d_count, ":count")
                    CREATE_LISP_NAME(symbol, "symbol")
                    CREATE_LISP_NAME(integer, "integer")
                    CREATE_LISP_NAME(function, "function")
                    CREATE_LISP_NAME(number, "number")
                    CREATE_LISP_NAME_P1(type_of, "type-of")
                    CREATE_LISP_NAME(contains, "contains")
                    CREATE_LISP_NAME(not_contains, "not-contains")
                    CREATE_LISP_NAME(add, "add")
                    CREATE_LISP_NAME(agent, "agent")
                    CREATE_LISP_NAME_P2_KEY(l_delete, "delete")
                    CREATE_LISP_NAME_P2_REST(map, "map")




#undef CREATE_LISP_NAME

#undef CREATE_LISP_NAME_P0
#undef CREATE_LISP_NAME_P1
#undef CREATE_LISP_NAME_P2
#undef CREATE_LISP_NAME_P3
#undef CREATE_LISP_NAME_P0_REST
#undef CREATE_LISP_NAME_P1_REST
#undef CREATE_LISP_NAME_P2_REST
#undef CREATE_LISP_NAME_P3_REST


#undef CREATE_LISP_NAME_P0_KEY
#undef CREATE_LISP_NAME_P1_KEY
#undef CREATE_LISP_NAME_P2_KEY
#undef CREATE_LISP_NAME_P3_KEY
                   };

#endif // LISPNAMES_H

