/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "utiintvector.h"

HResult CIVector3::Read(CStream & Stream, int Flags, int version)
{
   x = Stream.getInt32();
   y = Stream.getInt32();
   z = Stream.getInt32();
   return 0;
}

HResult CIVector3::Write(CStream & Stream, int Flags, int version) const
{

    Stream.writeInt32(x);
    Stream.writeInt32(y);
    Stream.writeInt32(z);
    return 0;
}

HResult CIVector2::Read(CStream & Stream, int Flags, int version)
{
   x = Stream.getInt32();
   y = Stream.getInt32();
   return 0;
}

HResult CIVector2::Write(CStream & Stream, int Flags, int version)
{

    Stream.writeInt32(x);
    Stream.writeInt32(y);
    return 0;
}

HResult CIVector4::Read(CStream & Stream, int Flags, int version)
{
   x = Stream.getInt32();
   y = Stream.getInt32();
   z = Stream.getInt32();
   w = Stream.getInt32();
   return 0;
}

HResult CIVector4::Write(CStream & Stream, int Flags, int version)
{

    Stream.writeInt32(x);
    Stream.writeInt32(y);
    Stream.writeInt32(z);
    Stream.writeInt32(w);
    return 0;
}

