/***************************************************************************
 *   Copyright (C) 2006 by Michael Staud   *
 *   michael.staud@uni-ulm.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "prologengine.h"

namespace UtiProlog {
BaseEngine::BaseEngine()
{
   factparent = NULL;
   owner = NULL;
}

BaseEngine::~BaseEngine()
{
   
}

void BaseEngine::error(const wchar_t* text)
{
   Program::getInstance()->haserror = true;
	wcout << pos.beginline << "/" << pos.begincolumn << " - " << pos.endline << "/" << pos.endcolumn << L": " << text << endl;
}

}
