(define (domain airport)
(:requirements :equality :typing :numeric-fluents :negative-preconditions :conditional-effects)
(:types
   TObject - object
   TAirport - object
   TCargo - TObject
   TAirPlane - TObject
)
(:predicates
   (TIn ?m_cargo - TCargo ?m_airplane - TAirPlane)
   (TAt ?m_cargo - TObject ?m_airport - TAirport)
)
(:functions
(TCounter_m_count)
)
(:action load
   :parameters (?c - TCargo ?airport - TAirport ?p - TAirPlane )
   :precondition (and 
       (TAt ?c ?airport)
       (TAt ?p ?airport)
   )
   :effect 
      (and 
      (not (TAt ?c ?airport))
      (TIn ?c ?p)
      )
   
)
(:action unload
   :parameters (?c - TCargo ?airport - TAirport ?p - TAirPlane )
   :precondition (and 
       (TIn ?c ?p)
       (TAt ?p ?airport)
   )
   :effect 
      (and 
      (not (TIn ?c ?p))
      (TAt ?c ?airport)
      )
   
)
(:action fly
   :parameters (?p - TAirPlane ?oldairport - TAirport ?newairpot - TAirport )
   :precondition (and 
       (TAt ?p ?oldairport)
       
   )
   :effect 
      (and 
      (assign (TCounter_m_count) (+ (TCounter_m_count) 1))
      (when (< (+ (TCounter_m_count) 1) 10) 
         (and 
         (not (TAt ?p ?oldairport))
         (TAt ?p ?newairpot)
         )
      )
      )
   
)
)