   #ifndef __GEN_DOC_CDirDirectory_HEADER__
   #define __GEN_DOC_CDirDirectory_HEADER__
   
   #include "Uti3DCore.h"
   #include "Uti3DMath.h"
   #include "UtiString.h"
   
   
   #include <vector>

   #include <map>

                  
              
        class CDirFile;
      
        class CDirDirectory;
      
   
   class CDirectoryTree;
   class CDirDirectory;
   #include "CDirectoryItem.h"
   
   class CDirDirectory : public CDirectoryItem
   {
      protected:

        std::vector<CDirectoryItem*> Children_array;
	 
	     void insertItem_Children(CDirectoryItem* item);
	     void removeItem_Children(CDirectoryItem* item);
	     void clearItem_Children();
	 
	   std::map<CUtiString, CDirectoryItem*> Children_Name_index1;
	   std::map<CDirectoryItem*, CUtiString> Children_Name_index2;
	
	          
                  
                  
              
      public:
	 CDirDirectory(CDirectoryTree* pt, CDirDirectory* pn);
	 ~CDirDirectory();
CDirFile* getFile(const CUtiString& path, bool create);
   CDirDirectory* getDirectory(const CUtiString& path, bool create);
   CDirectoryItem* getNodeByPath(const CUtiString& path, int startpos, bool create);
   
         void addChildren(CDirectoryItem* arg0);
	 void insertChildren(int i, CDirectoryItem* arg0);
	 void deleteChildren(int i);
	 void removeChildren(CDirectoryItem* arg0);
	 int indexOfChildren(CDirectoryItem* arg0);
	 void clearChildren();
	 int getChildrenCount();
	 CDirectoryItem* getChildren(int i);
	 void setChildren(int i, CDirectoryItem* arg0);
	
	 CDirectoryItem* getChildren_Name_index(const CUtiString &value) const;
	     void changeChildren_Name_index(CDirectoryItem* v);
	 CDirFile* addChildren_CDirFile(const CUtiString & Name);
      CDirDirectory* addChildren_CDirDirectory(const CUtiString & Name);
      
      
   };
   #endif
