#include "matrices.h" 

unsigned int ggT(unsigned int a, unsigned int b)
{
    if (b == 0) {
        return a;
    }
    return ggT(b, a % b);
}

long ggTLong(long a, long b)
{
    assert(a >= 0);
    assert(b >= 0);
    if (b == 0) {
        return a;
    }
    return ggT(b, a % b);
}


CUtiString convertToString(int i, int s)
{
  CUtiString str;
  str = (i);
  str.ExpandToSize(s);
  return str;
}

CUtiString convertToString(float i, int s)
{
  CUtiString str;
  str = (i);
  str.ExpandToSize(s);
  return str;
}

CUtiString convertToString(double i, int s)
{
  CUtiString str;
  str = (float)(i);
  str.ExpandToSize(s);
  return str;
}

UMat<int> UALL;
