/* A Bison parser, made by GNU Bison 2.1.  */

/* C++ Skeleton parser for LALR(1) parsing with Bison,
   Copyright (C) 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */


#include "plparse.tab.h"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* A pseudo ostream that takes yydebug_ into account. */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

/* Enable debugging if requested.  */
#if YYDEBUG

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << (Title) << ' ';			\
      yysymprint_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (0)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yyreduce_print_ (Rule);		\
} while (0)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (0)

#else /* !YYDEBUG */

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

#if YYERROR_VERBOSE

/* Return YYSTR after stripping away unnecessary quotes and
   backslashes, so that it's suitable for yyerror.  The heuristic is
   that double-quoting is unnecessary unless the string contains an
   apostrophe, a comma, or backslash (other than backslash-backslash).
   YYSTR is taken from yytname.  */
std::string
yy::prologxx_parser::yytnamerr_ (const char *yystr)
{
  if (*yystr == '"')
    {
      std::string yyr = "";
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    yyr += *yyp;
	    break;

	  case '"':
	    return yyr;
	  }
    do_not_strip_quotes: ;
    }

  return yystr;
}

#endif

#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

void
yy::prologxx_parser::yysymprint_ (int yytype,
                         const semantic_type* yyvaluep, const location_type* yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;
  /* Backward compatibility, but should be removed eventually. */
  std::ostream& cdebug_ = *yycdebug_;
  (void) cdebug_;

  *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	     << ' ' << yytname_[yytype] << " ("
             << *yylocationp << ": ";
  switch (yytype)
    {
      default:
        break;
    }
  *yycdebug_ << ')';
}
#endif /* ! YYDEBUG */

void
yy::prologxx_parser::yydestruct_ (const char* yymsg,
                         int yytype, semantic_type* yyvaluep, location_type* yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yymsg;
  (void) yyvaluep;
  (void) yylocationp;

  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}

void
yy::prologxx_parser::yypop_ (unsigned int n)
{
  yystate_stack_.pop (n);
  yysemantic_stack_.pop (n);
  yylocation_stack_.pop (n);
}

std::ostream&
yy::prologxx_parser::debug_stream () const
{
  return *yycdebug_;
}

void
yy::prologxx_parser::set_debug_stream (std::ostream& o)
{
  yycdebug_ = &o;
}


yy::prologxx_parser::debug_level_type
yy::prologxx_parser::debug_level () const
{
  return yydebug_;
}

void
yy::prologxx_parser::set_debug_level (debug_level_type l)
{
  yydebug_ = l;
}


int
yy::prologxx_parser::parse ()
{
  /* Look-ahead and look-ahead in internal form.  */
  int yylooka;
  int yyilooka;

  /// Semantic value of the look-ahead.
  semantic_type yylval;
  /// Location of the look-ahead.
  location_type yylloc;
  /// The locations where the error started and ended.
  location yyerror_range[2];

  /// $$.
  semantic_type yyval;
  /// @$.
  location_type yyloc;

  int yyresult_;

  YYCDEBUG << "Starting parse" << std::endl;

  yynerrs_ = 0;
  yyerrstatus_ = 0;

  /* Start.  */
  yystate_ = 0;
  yylooka = yyempty_;


  /* User initialization code. */
  #line 37 "plparse.y"
{
   yylloc.begin.filename = yylloc.end.filename = &driver.file;
}
/* Line 548 of yacc.c.  */
#line 238 "plparse.tab.c"
  /* Initialize the stacks.  The initial state will be pushed in
     yynewstate, since the latter expects the semantical and the
     location values to have been already stored, initialize these
     stacks with a primary value.  */
  yystate_stack_ = state_stack_type (0);
  yysemantic_stack_ = semantic_stack_type (0);
  yylocation_stack_ = location_stack_type (0);
  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yylloc);

  /* New state.  */
yynewstate:
  yystate_stack_.push (yystate_);
  YYCDEBUG << "Entering state " << yystate_ << std::endl;
  goto yybackup;

  /* Backup.  */
yybackup:

  /* Try to take a decision without look-ahead.  */
  yyn_ = yypact_[yystate_];
  if (yyn_ == yypact_ninf_)
    goto yydefault;

  /* Read a look-ahead token.  */
  if (yylooka == yyempty_)
    {
      YYCDEBUG << "Reading a token: ";
      yylooka = yylex (&yylval, &yylloc, driver);
    }


  /* Convert token to internal form.  */
  if (yylooka <= yyeof_)
    {
      yylooka = yyilooka = yyeof_;
      YYCDEBUG << "Now at end of input." << std::endl;
    }
  else
    {
      yyilooka = yytranslate_ (yylooka);
      YY_SYMBOL_PRINT ("Next token is", yyilooka, &yylval, &yylloc);
    }

  /* If the proper action on seeing token ILOOKA_ is to reduce or to
     detect an error, take that action.  */
  yyn_ += yyilooka;
  if (yyn_ < 0 || yylast_ < yyn_ || yycheck_[yyn_] != yyilooka)
    goto yydefault;

  /* Reduce or error.  */
  yyn_ = yytable_[yyn_];
  if (yyn_ < 0)
    {
      if (yyn_ == yytable_ninf_)
	goto yyerrlab;
      else
	{
	  yyn_ = -yyn_;
	  goto yyreduce;
	}
    }
  else if (yyn_ == 0)
    goto yyerrlab;

  /* Accept?  */
  if (yyn_ == yyfinal_)
    goto yyacceptlab;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yyilooka, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yylooka != yyeof_)
    yylooka = yyempty_;

  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yylloc);

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus_)
    --yyerrstatus_;

  yystate_ = yyn_;
  goto yynewstate;

/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn_ = yydefact_[yystate_];
  if (yyn_ == 0)
    goto yyerrlab;
  goto yyreduce;

/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  yylen_ = yyr2_[yyn_];
  /* If LEN_ is nonzero, implement the default value of the action:
     `$$ = $1'.  Otherwise, use the top of the stack.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  */
  if (yylen_)
    yyval = yysemantic_stack_[yylen_ - 1];
  else
    yyval = yysemantic_stack_[0];

  {
    slice<location_type, location_stack_type> slice (yylocation_stack_, yylen_);
    YYLLOC_DEFAULT (yyloc, slice, yylen_);
  }
  YY_REDUCE_PRINT (yyn_);
  switch (yyn_)
    {
        case 3:
#line 92 "plparse.y"
    {DEBUGMODE(wcout << "program -> program declaration\n");;}
    break;

  case 4:
#line 93 "plparse.y"
    {;}
    break;

  case 5:
#line 96 "plparse.y"
    {
	Term* str = dynamic_cast<Term*>((yysemantic_stack_[1].element));
   assert(str != NULL);
   driver.newstr = str;
   DEBUGMODE(wcout << "SELECTED_ONEFACT term '.'\n");
   
;}
    break;

  case 6:
#line 104 "plparse.y"
    {
  
   Fact* f = dynamic_cast<Fact*>((yysemantic_stack_[1].element));
   assert(f != NULL);
  // addFact(f);
   
   Program::getInstance()->addElement(f);
   DEBUGMODE(wcout << "declaration -> fact\n");;}
    break;

  case 7:
#line 112 "plparse.y"
    {
	   Rule* f = dynamic_cast<Rule*>((yysemantic_stack_[1].element));
	   Program::getInstance()->addRule(f);
	   
	;}
    break;

  case 8:
#line 117 "plparse.y"
    {/*yyerrok;*/;}
    break;

  case 9:
#line 121 "plparse.y"
    {
		Rule* f = dynamic_cast<Rule*>((yysemantic_stack_[0].element));
	(yyval.element) = f;
;}
    break;

  case 10:
#line 126 "plparse.y"
    {
	(yyval.element) = (yysemantic_stack_[0].element);
;}
    break;

  case 11:
#line 130 "plparse.y"
    {
	(yyval.id) = (yysemantic_stack_[1].id);	
;}
    break;

  case 12:
#line 135 "plparse.y"
    {
	Rule* f = dynamic_cast<Rule*>((yysemantic_stack_[3].element));
	SETPOS(f);
	f->setGuard(dynamic_cast<Body*>((yysemantic_stack_[1].element)));
	f->setBody(dynamic_cast<Body*>((yysemantic_stack_[0].element)));
	f->setType(Rule::Simplification);
	(yyval.element) = f;
;}
    break;

  case 13:
#line 144 "plparse.y"
    {
	Rule* f = dynamic_cast<Rule*>((yysemantic_stack_[3].element));
	SETPOS(f);
	f->setGuard(dynamic_cast<Body*>((yysemantic_stack_[1].element)));
	f->setBody(dynamic_cast<Body*>((yysemantic_stack_[0].element)));
	f->setType(Rule::Propagation);
	(yyval.element) = f;
;}
    break;

  case 14:
#line 154 "plparse.y"
    {
	Rule* f = dynamic_cast<Rule*>((yysemantic_stack_[2].element));
	SETPOS(f);
	f->setBody(dynamic_cast<Body*>((yysemantic_stack_[0].element)));
	f->setType(Rule::Simplification);
	(yyval.element) = f;
;}
    break;

  case 15:
#line 162 "plparse.y"
    {
	Rule* f = dynamic_cast<Rule*>((yysemantic_stack_[2].element));
	SETPOS(f);
	f->setBody(dynamic_cast<Body*>((yysemantic_stack_[0].element)));
	f->setType(Rule::Propagation);
	(yyval.element) = f;
;}
    break;

  case 16:
#line 171 "plparse.y"
    {
	(yyval.element) = (yysemantic_stack_[1].element);
;}
    break;

  case 18:
#line 177 "plparse.y"
    {
	Rule* f = EngineFactory::getInstance()->createRule();
	SETPOS(f);
	f->addHead((Structure*)(yysemantic_stack_[0].element));
	(yyval.element) = f;
;}
    break;

  case 19:
#line 184 "plparse.y"
    {
	Rule* f = (Rule*)(yysemantic_stack_[2].element);
	SETPOS(f);
	f->addHead((Structure*)(yysemantic_stack_[0].element));
	(yyval.element) = f;
;}
    break;

  case 20:
#line 192 "plparse.y"
    {
   Fact* fact = EngineFactory::getInstance()->createFact();
   SETPOS(fact);
   Structure* str = dynamic_cast<Structure*>((yysemantic_stack_[0].element));
   assert(str != NULL);
   fact->setHead(str);
   (yyval.element) = fact;
   DEBUGMODE(wcout << "fact -> predicate\n");
;}
    break;

  case 21:
#line 202 "plparse.y"
    {
	Fact* fact = EngineFactory::getInstance()->createFact();
	SETPOS(fact);
   Structure* str = dynamic_cast<Structure*>((yysemantic_stack_[2].element));
   assert(str != NULL);
   fact->setHead(str);
   Body* body = dynamic_cast<Body*>((yysemantic_stack_[0].element));
   assert(body != NULL);
   fact->setBody(body);
   (yyval.element) = fact;
   DEBUGMODE(wcout << "fact -> predicate :- body\n");
;}
    break;

  case 22:
#line 215 "plparse.y"
    {
	Fact* fact = EngineFactory::getInstance()->createFact();
	SETPOS(fact);
   fact->setHead(NULL);
   Body* body = dynamic_cast<Body*>((yysemantic_stack_[0].element));
   assert(body != NULL);
   fact->setBody(body);
   (yyval.element) = fact;
   DEBUGMODE(wcout << "fact -> :- body\n");
;}
    break;

  case 23:
#line 228 "plparse.y"
    {
	Structure* structure = EngineFactory::getInstance()->createStructure();
	SETPOS(structure);
   structure->setName((yysemantic_stack_[0].id));
   (yyval.element) = structure;   
//   addStructure(structure);
   DEBUGMODE(wcout << "predicate -> functor\n");
;}
    break;

  case 24:
#line 237 "plparse.y"
    {
	Structure* structure = dynamic_cast<Structure*>((yysemantic_stack_[1].element));
   assert(structure != NULL);
   structure->setName((yysemantic_stack_[3].id));
   (yyval.element) = structure;   
  // addStructure(structure);
   DEBUGMODE(wcout << "predicate -> functor '(' arguments ')'");
;}
    break;

  case 25:
#line 247 "plparse.y"
    {(yyval.id) = (yysemantic_stack_[0].id);DEBUGMODE(wcout << "functor -> atom\n");;}
    break;

  case 26:
#line 251 "plparse.y"
    {
	Structure* structure = EngineFactory::getInstance()->createStructure();
	SETPOS(structure);
   assert(dynamic_cast<Term*>((yysemantic_stack_[0].element)) != NULL);
   Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
   assert(t != NULL);
   structure->addElement(t);
   (yyval.element) = structure;
   DEBUGMODE(wcout << "arguments -> term\n");
;}
    break;

  case 27:
#line 262 "plparse.y"
    {
   
	Structure* structure = dynamic_cast<Structure*>((yysemantic_stack_[2].element));
    assert(structure != NULL);
    Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
    assert(t != NULL);
    structure->addElement(t);
    (yyval.element) = structure;
    DEBUGMODE(wcout << "arguments -> arguments ',' term\n");
;}
    break;

  case 28:
#line 277 "plparse.y"
    {(yyval.element) = (yysemantic_stack_[0].element);DEBUGMODE(wcout << "term -> var\n");;}
    break;

  case 29:
#line 278 "plparse.y"
    {(yyval.element) = (yysemantic_stack_[0].element);DEBUGMODE(wcout << "term -> number\n");;}
    break;

  case 30:
#line 279 "plparse.y"
    {(yyval.element) = (yysemantic_stack_[0].element);DEBUGMODE(wcout << "term -> structure\n");;}
    break;

  case 31:
#line 280 "plparse.y"
    {(yyval.element) = (yysemantic_stack_[0].element);DEBUGMODE(wcout << "term -> list\n");;}
    break;

  case 32:
#line 281 "plparse.y"
    {(yyval.element) = (yysemantic_stack_[0].element);DEBUGMODE(wcout << "term -> stringlist\n");;}
    break;

  case 33:
#line 340 "plparse.y"
    {
	Var* var = EngineFactory::getInstance()->createVar();
	SETPOS(var);
   var->setName((yysemantic_stack_[0].id));
   (yyval.element) = var;
   DEBUGMODE(wcout << "DONTCARE\n");
;}
    break;

  case 34:
#line 348 "plparse.y"
    {
	Var* var = EngineFactory::getInstance()->createVar();
	SETPOS(var);
   var->setName((yysemantic_stack_[0].id));
   (yyval.element) = var;
   DEBUGMODE(wcout << "VARIABLE\n");
;}
    break;

  case 35:
#line 357 "plparse.y"
    {(yyval.id) = (yysemantic_stack_[0].id);DEBUGMODE(wcout << "atom: \n");;}
    break;

  case 36:
#line 359 "plparse.y"
    {
	(yyval.id)  = EngineFactory::getInstance()->registerAtom(".");
	DEBUGMODE(wcout << "atom: '.'\n");
;}
    break;

  case 37:
#line 365 "plparse.y"
    {
	IntNumber* integer = EngineFactory::getInstance()->createIntNumber();
	SETPOS(integer);
   integer->setValue((yysemantic_stack_[0].integer));
   (yyval.element) = integer;
   DEBUGMODE(wcout << "numberi: \n");
   ;}
    break;

  case 38:
#line 372 "plparse.y"
    {
	   RealNumber* real = EngineFactory::getInstance()->createRealNumber();
   SETPOS(real);
   real->setValue((yysemantic_stack_[0].real));
   (yyval.element) = real;
   DEBUGMODE(wcout << "numberf: \n");
;}
    break;

  case 39:
#line 384 "plparse.y"
    {
	char* c = (yyval.string);
   PID dot = EngineFactory::getInstance()->registerAtom(".");
   PID emptylist = EngineFactory::getInstance()->registerAtom("[]");
   Structure* lastelement = NULL;
   int length = strlen(c);
   Structure* r_struct;
   if (length == 0) {
	Structure* structure;
   r_struct= EngineFactory::getInstance()->createStructure();
   SETPOS(r_struct);
       structure = r_struct;
       structure->setName(emptylist);
   } else {
      Structure* structure;
      r_struct = EngineFactory::getInstance()->createStructure();
      SETPOS(r_struct);
      structure = r_struct;
      IntNumber* intvalue = EngineFactory::getInstance()->createIntNumber();
      SETPOS(intvalue);
      intvalue->setValue(c[0]);
      structure->addElement(intvalue);
      
      structure->setName(dot);
      lastelement=r_struct;
      for (int i = 1; i < length; i++) {
	      structure = EngineFactory::getInstance()->createStructure();
      SETPOS(structure);
      intvalue = EngineFactory::getInstance()->createIntNumber();
      SETPOS(intvalue);
          intvalue->setValue(c[i]);
          structure->addElement(intvalue);
          structure->setName(dot);
	  lastelement->addElement(structure);
	  lastelement = structure;
      };
      structure = EngineFactory::getInstance()->createStructure();
      SETPOS(structure);
      structure->setName(emptylist);
      lastelement->addElement(structure);
   };
   //Structure* structure = cf->createStructure();
   //structure->setName();
   //wcout << c << endl;
   (yyval.element) = r_struct;
   delete c;
;}
    break;

  case 40:
#line 434 "plparse.y"
    {
	(yyval.element) = (yysemantic_stack_[1].le).element;
	DEBUGMODE(wcout <<"list -> [liste]\n");
;}
    break;

  case 41:
#line 439 "plparse.y"
    {
	(yyval.element) = (yysemantic_stack_[1].element);
	DEBUGMODE(wcout <<"list -> {bracket}\n");
;}
    break;

  case 42:
#line 445 "plparse.y"
    {
	Structure* structure = EngineFactory::getInstance()->createStructure();
	SETPOS(structure);
	structure->setName(EngineFactory::getInstance()->registerAtom("."));
	assert(dynamic_cast<Term*>((yysemantic_stack_[0].element)) != NULL);
	Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
   assert(t != NULL);
   structure->addElement(t);
   Structure* closelist = EngineFactory::getInstance()->createStructure();
   SETPOS(closelist);
   closelist->setName(EngineFactory::getInstance()->registerAtom("[]"));
   structure->addElement(closelist);
   //$$.element = structure;
   (yyval.le).element = structure;
   (yyval.le).laststruct = structure;
	
	DEBUGMODE(wcout << "liste -> term\n");

;}
    break;

  case 43:
#line 464 "plparse.y"
    {
	
	Structure* structure = dynamic_cast<Structure*>((yysemantic_stack_[2].le).element);
	Structure* lastelement = (yysemantic_stack_[2].le).laststruct;
	assert(structure != NULL);
	assert(lastelement != NULL);
	
	Structure* newstruct = EngineFactory::getInstance()->createStructure();
	SETPOS(newstruct);
	newstruct->setName(EngineFactory::getInstance()->registerAtom("."));
	
	Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
	assert(t != NULL);
	newstruct->addElement(t);
	newstruct->addElement(lastelement->getElement(1));
	lastelement->setElement(1, newstruct);
	(yyval.le).element = structure;
	(yyval.le).laststruct = newstruct;
	DEBUGMODE(wcout << "liste -> liste,term\n");

;}
    break;

  case 44:
#line 485 "plparse.y"
    {
	Structure* structure = dynamic_cast<Structure*>((yysemantic_stack_[2].le).element);
	Structure* lastelement = (yysemantic_stack_[2].le).laststruct;
	assert(structure != NULL);
	assert(lastelement != NULL);
	Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
	Term* t2 =  lastelement->getElement(1);
	
	lastelement->setElement(1, t);
	delete t2;
	(yyval.le).element = structure;
	(yyval.le).laststruct = lastelement;
	DEBUGMODE(wcout << "liste -> liste|term\n");

;}
    break;

  case 45:
#line 502 "plparse.y"
    {
	Structure* structure = EngineFactory::getInstance()->createStructure();
	SETPOS(structure);
	structure->setName(EngineFactory::getInstance()->registerAtom("{}"));
	assert(dynamic_cast<Term*>((yysemantic_stack_[0].element)) != NULL);
	Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
	assert(t != NULL);
	structure->addElement(t);
	(yyval.element) = structure;
	
	DEBUGMODE(wcout << "brace -> term\n");

;}
    break;

  case 46:
#line 515 "plparse.y"
    {
	
	Structure* structure = dynamic_cast<Structure*>((yysemantic_stack_[2].element));
    assert(structure != NULL);
    Term *t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
    assert(t != NULL);
    structure->addElement(t);
    (yyval.element) = structure;
    DEBUGMODE(wcout << "brace -> brace,term\n");

;}
    break;

  case 47:
#line 529 "plparse.y"
    {
   Body* body = EngineFactory::getInstance()->createBody();
   SETPOS(body);
   BodyPart* g = dynamic_cast<BodyPart*>((yysemantic_stack_[0].element));
   assert(g != NULL);
   body->addElement(g);
   (yyval.element) = body;
   DEBUGMODE(wcout << "body -> bodypart\n");
;}
    break;

  case 48:
#line 539 "plparse.y"
    {
   Body* body = dynamic_cast<Body*>((yysemantic_stack_[2].element));
   assert(body != NULL);
   BodyPart* g = dynamic_cast<BodyPart*>((yysemantic_stack_[0].element));
   assert(g != NULL);
   body->addElement(g);
   (yyval.element) = body;
   DEBUGMODE(wcout << "body -> body ; bodypart\n");
;}
    break;

  case 49:
#line 551 "plparse.y"
    {
   BodyPart* part = EngineFactory::getInstance()->createBodyPart();
   SETPOS(part);
   Goal* g = dynamic_cast<Goal*>((yysemantic_stack_[0].element));
   assert(g != NULL);
   part->addElement(g);
   (yyval.element) = part;
   DEBUGMODE(wcout << "bodypart -> goal\n");
;}
    break;

  case 50:
#line 561 "plparse.y"
    {
	BodyPart* part = dynamic_cast<BodyPart*>((yysemantic_stack_[2].element));
   assert(part != NULL);
   Goal* g = dynamic_cast<Goal*>((yysemantic_stack_[0].element));
   assert(g != NULL);
   part->addElement(g);
   (yyval.element) = part;
   DEBUGMODE(wcout << "bodypart -> bodypart ',' goal\n");
;}
    break;

  case 51:
#line 573 "plparse.y"
    {
	Goal* goal = EngineFactory::getInstance()->createGoal();
	SETPOS(goal);
   goal->setGoal(gTerm);
   Term* t = dynamic_cast<Term*>((yysemantic_stack_[0].element));
   assert(t != NULL);
   goal->setElement(t);
   (yyval.element) = goal;
   DEBUGMODE(wcout << "goal -> term\n");

;}
    break;

  case 52:
#line 585 "plparse.y"
    {
	Goal* goal = EngineFactory::getInstance()->createGoal();
	SETPOS(goal);
   goal->setGoal(gBody);
   Body* t = dynamic_cast<Body*>((yysemantic_stack_[1].element));
   assert(t != NULL);
   goal->setElement(t);
   (yyval.element) = goal;
   DEBUGMODE(wcout << "goal -> '(' body ')'\n");
;}
    break;

  case 53:
#line 596 "plparse.y"
    {
   Goal* goal = EngineFactory::getInstance()->createGoal();
	SETPOS(goal);
   goal->setGoal(gNotBody);
   Goal* g = dynamic_cast<Goal*>((yysemantic_stack_[0].element));
 //  Body* t = dynamic_cast<Body*>($<element>2);
   assert(g != NULL);
   goal->setElement(g);
   (yyval.element) = goal;
   DEBUGMODE(wcout << "goal -> \\+ goal \n");
;}
    break;


      default: break;
    }

/* Line 676 of lalr1.cc.  */
#line 949 "plparse.tab.c"

  yypop_ (yylen_);

  YY_STACK_PRINT ();

  yysemantic_stack_.push (yyval);
  yylocation_stack_.push (yyloc);

  /* Shift the result of the reduction.  */
  yyn_ = yyr1_[yyn_];
  yystate_ = yypgoto_[yyn_ - yyntokens_] + yystate_stack_[0];
  if (0 <= yystate_ && yystate_ <= yylast_
      && yycheck_[yystate_] == yystate_stack_[0])
    yystate_ = yytable_[yystate_];
  else
    yystate_ = yydefgoto_[yyn_ - yyntokens_];
  goto yynewstate;

/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus_)
    {
      ++yynerrs_;
      error (yylloc, yysyntax_error_ (YYERROR_VERBOSE_IF (yyilooka)));
    }

  yyerror_range[0] = yylloc;
  if (yyerrstatus_ == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yylooka <= yyeof_)
        {
	  /* Return failure if at end of input.  */
	  if (yylooka == yyeof_)
	    YYABORT;
        }
      else
        {
          yydestruct_ ("Error: discarding", yyilooka, &yylval, &yylloc);
          yylooka = yyempty_;
        }
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (false)
    goto yyerrorlab;

  yyerror_range[0] = yylocation_stack_[yylen_ - 1];
  yypop_ (yylen_);
  yystate_ = yystate_stack_[0];
  goto yyerrlab1;

/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn_ = yypact_[yystate_];
      if (yyn_ != yypact_ninf_)
	{
	  yyn_ += yyterror_;
	  if (0 <= yyn_ && yyn_ <= yylast_ && yycheck_[yyn_] == yyterror_)
	    {
	      yyn_ = yytable_[yyn_];
	      if (0 < yyn_)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yystate_stack_.height () == 1)
	YYABORT;

      yyerror_range[0] = yylocation_stack_[0];
      yydestruct_ ("Error: popping",
                   yystos_[yystate_],
                   &yysemantic_stack_[0], &yylocation_stack_[0]);
      yypop_ ();
      yystate_ = yystate_stack_[0];
      YY_STACK_PRINT ();
    }

  if (yyn_ == yyfinal_)
    goto yyacceptlab;

  yyerror_range[1] = yylloc;
  // Using YYLLOC is tempting, but would change the location of
  // the look-ahead.  YYLOC is available though.
  YYLLOC_DEFAULT (yyloc, yyerror_range - 1, 2);
  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yyloc);

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos_[yyn_],
		   &yysemantic_stack_[0], &yylocation_stack_[0]);

  yystate_ = yyn_;
  goto yynewstate;

  /* Accept.  */
yyacceptlab:
  yyresult_ = 0;
  goto yyreturn;

  /* Abort.  */
yyabortlab:
  yyresult_ = 1;
  goto yyreturn;

yyreturn:
  if (yylooka != yyeof_ && yylooka != yyempty_)
    yydestruct_ ("Cleanup: discarding lookahead", yyilooka, &yylval, &yylloc);

  while (yystate_stack_.height () != 1)
    {
      yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
      yypop_ ();
    }

  return yyresult_;
}

// Generate an error message.
std::string
yy::prologxx_parser::yysyntax_error_ (YYERROR_VERBOSE_IF (int tok))
{
  std::string res;
#if YYERROR_VERBOSE
  yyn_ = yypact_[yystate_];
  if (yypact_ninf_ < yyn_ && yyn_ < yylast_)
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  */
      int yyxbegin = yyn_ < 0 ? -yyn_ : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = yylast_ - yyn_;
      int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
      int count = 0;
      for (int x = yyxbegin; x < yyxend; ++x)
        if (yycheck_[x + yyn_] == x && x != yyterror_)
          ++count;

      // FIXME: This method of building the message is not compatible
      // with internationalization.  It should work like yacc.c does it.
      // That is, first build a string that looks like this:
      // "syntax error, unexpected %s or %s or %s"
      // Then, invoke YY_ on this string.
      // Finally, use the string as a format to output
      // yytname_[tok], etc.
      // Until this gets fixed, this message appears in English only.
      res = "syntax error, unexpected ";
      res += yytnamerr_ (yytname_[tok]);
      if (count < 5)
        {
          count = 0;
          for (int x = yyxbegin; x < yyxend; ++x)
            if (yycheck_[x + yyn_] == x && x != yyterror_)
              {
                res += (!count++) ? ", expecting " : " or ";
                res += yytnamerr_ (yytname_[x]);
              }
        }
    }
  else
#endif
    res = YY_("syntax error");
  return res;
}


/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
const signed char yy::prologxx_parser::yypact_ninf_ = -38;
const signed char
yy::prologxx_parser::yypact_[] =
{
       8,    18,    64,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,    18,    18,   -38,   -11,    16,   -38,   -38,   -38,   -38,
     -38,   -38,    17,    40,   -38,    21,     2,   -38,     7,    28,
      36,     1,    52,   -38,    -8,   -38,    11,    18,   -38,   -38,
      40,    40,   -38,    25,    49,   -38,   -38,   -38,   -38,    40,
      40,     2,   -38,    40,   -38,    18,    18,   -38,    18,   -38,
      23,   -38,   -38,    34,    40,    40,    40,   -10,    40,   -10,
     -38,    25,   -38,   -38,   -38,    18,   -38,   -38,    49,   -38,
      25,   -38,    25,   -38
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error.  */
const unsigned char
yy::prologxx_parser::yydefact_[] =
{
       2,     0,     0,     4,    37,    38,    35,    34,    39,    36,
      33,     0,     0,    30,    23,     0,    28,    25,    29,    32,
      31,     1,     0,     0,     3,     0,     0,    10,     0,    17,
       0,    18,    25,    42,     0,    45,     0,     0,     5,     8,
       0,     0,    51,    22,    47,    49,     7,     9,    18,     0,
       0,     0,     6,     0,    11,     0,     0,    40,     0,    41,
       0,    26,    53,     0,     0,     0,     0,    14,     0,    15,
      19,    21,    44,    43,    46,     0,    24,    52,    48,    50,
      12,    16,    13,    27
};

/* YYPGOTO[NTERM-NUM].  */
const signed char
yy::prologxx_parser::yypgoto_[] =
{
     -38,   -38,   -38,   -38,   -38,   -38,    41,    22,   -38,   -38,
     -38,     0,   -38,   -38,    -1,   -38,    66,   -38,   -38,   -38,
     -38,   -38,   -37,     9,   -35
};

/* YYDEFGOTO[NTERM-NUM].  */
const signed char
yy::prologxx_parser::yydefgoto_[] =
{
      -1,     2,     3,    24,    25,    26,    27,    66,    28,    29,
      30,    13,    14,    60,    42,    16,    17,    18,    19,    20,
      34,    36,    43,    44,    45
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.  */
const signed char yy::prologxx_parser::yytable_ninf_ = -21;
const signed char
yy::prologxx_parser::yytable_[] =
{
      15,    81,    31,    55,    63,    62,    53,    37,     6,    56,
      33,    35,    67,    69,    57,    64,    71,   -20,     9,    49,
      50,     4,     5,     1,     6,     7,    48,     8,    58,    80,
      79,    82,    38,    39,     9,    59,    61,    46,    10,    11,
      75,    12,    76,     4,     5,    51,     6,     7,    40,     8,
      64,    70,    52,    77,    72,    73,     9,    74,    41,    64,
      10,    11,    54,    12,    21,    22,    65,    47,    32,    23,
       6,     0,    68,    78,    83,     0,     0,     0,     0,     0,
       9
};

/* YYCHECK.  */
const signed char
yy::prologxx_parser::yycheck_[] =
{
       1,    11,     2,    11,    41,    40,     5,    18,     6,    17,
      11,    12,    49,    50,    22,    25,    53,    16,    16,    12,
      13,     3,     4,    15,     6,     7,    26,     9,    17,    66,
      65,    68,    16,    16,    16,    24,    37,    16,    20,    21,
      17,    23,    19,     3,     4,    17,     6,     7,     8,     9,
      25,    51,    16,    19,    55,    56,    16,    58,    18,    25,
      20,    21,    10,    23,     0,     1,    17,    26,     2,     5,
       6,    -1,    50,    64,    75,    -1,    -1,    -1,    -1,    -1,
      16
};

/* STOS_[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
const unsigned char
yy::prologxx_parser::yystos_[] =
{
       0,    15,    27,    28,     3,     4,     6,     7,     9,    16,
      20,    21,    23,    37,    38,    40,    41,    42,    43,    44,
      45,     0,     1,     5,    29,    30,    31,    32,    34,    35,
      36,    37,    42,    40,    46,    40,    47,    18,    16,    16,
       8,    18,    40,    48,    49,    50,    16,    32,    37,    12,
      13,    17,    16,     5,    10,    11,    17,    22,    17,    24,
      39,    40,    50,    48,    25,    17,    33,    48,    33,    48,
      37,    48,    40,    40,    40,    17,    19,    19,    49,    50,
      48,    11,    48,    40
};

#if YYDEBUG
/* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
   to YYLEX-NUM.  */
const unsigned short int
yy::prologxx_parser::yytoken_number_[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    46,    44,    40,    41,
      95,    91,    93,   123,   125,    59
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
const unsigned char
yy::prologxx_parser::yyr1_[] =
{
       0,    26,    27,    27,    27,    28,    29,    29,    29,    30,
      30,    31,    32,    32,    32,    32,    33,    34,    35,    35,
      36,    36,    36,    37,    37,    38,    39,    39,    40,    40,
      40,    40,    40,    41,    41,    42,    42,    43,    43,    44,
      45,    45,    46,    46,    46,    47,    47,    48,    48,    49,
      49,    50,    50,    50
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
const unsigned char
yy::prologxx_parser::yyr2_[] =
{
       0,     2,     0,     2,     1,     3,     2,     2,     2,     2,
       1,     2,     4,     4,     3,     3,     2,     1,     1,     3,
       1,     3,     2,     1,     4,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     3,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     2
};

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at \a yyntokens_, nonterminals. */
const char*
const yy::prologxx_parser::yytname_[] =
{
  "$end", "error", "$undefined", "INTNUM", "FLOATNUM", "BEGINBODY",
  "ATOM", "NORMALVAR", "NOTTOKEN", "STRINGLIST", "CONSTRAINT_ADD",
  "CONSTRAINT_GUARDEND", "CONSTRAINT_SIMPLIFICATION",
  "CONSTRAINT_PROPAGATION", "CONSTRAINT_ID", "SELECTED_ONEFACT", "'.'",
  "','", "'('", "')'", "'_'", "'['", "']'", "'{'", "'}'", "';'", "$accept",
  "program", "onefact", "declaration", "rule", "constraintname",
  "constraintrule", "guard", "head", "constraints", "fact", "predicate",
  "functor", "arguments", "term", "var", "atom", "number", "stringlist",
  "list", "liste", "brace", "body", "bodypart", "goal", 0
};
#endif

#if YYDEBUG
/* YYRHS -- A `-1'-separated list of the rules' RHS. */
const yy::prologxx_parser::rhs_number_type
yy::prologxx_parser::yyrhs_[] =
{
      27,     0,    -1,    -1,    27,    29,    -1,    28,    -1,    15,
      40,    16,    -1,    36,    16,    -1,    30,    16,    -1,     1,
      16,    -1,    31,    32,    -1,    32,    -1,    42,    10,    -1,
      34,    12,    33,    48,    -1,    34,    13,    33,    48,    -1,
      34,    12,    48,    -1,    34,    13,    48,    -1,    48,    11,
      -1,    35,    -1,    37,    -1,    35,    17,    37,    -1,    37,
      -1,    37,     5,    48,    -1,     5,    48,    -1,    38,    -1,
      38,    18,    39,    19,    -1,    42,    -1,    40,    -1,    39,
      17,    40,    -1,    41,    -1,    43,    -1,    37,    -1,    45,
      -1,    44,    -1,    20,    -1,     7,    -1,     6,    -1,    16,
      -1,     3,    -1,     4,    -1,     9,    -1,    21,    46,    22,
      -1,    23,    47,    24,    -1,    40,    -1,    46,    17,    40,
      -1,    46,    11,    40,    -1,    40,    -1,    47,    17,    40,
      -1,    49,    -1,    48,    25,    49,    -1,    50,    -1,    49,
      17,    50,    -1,    40,    -1,    18,    48,    19,    -1,     8,
      50,    -1
};

/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
const unsigned char
yy::prologxx_parser::yyprhs_[] =
{
       0,     0,     3,     4,     7,     9,    13,    16,    19,    22,
      25,    27,    30,    35,    40,    44,    48,    51,    53,    55,
      59,    61,    65,    68,    70,    75,    77,    79,    83,    85,
      87,    89,    91,    93,    95,    97,    99,   101,   103,   105,
     107,   111,   115,   117,   121,   125,   127,   131,   133,   137,
     139,   143,   145,   149
};

/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
const unsigned short int
yy::prologxx_parser::yyrline_[] =
{
       0,    91,    91,    92,    93,    96,   104,   112,   117,   121,
     125,   130,   134,   143,   153,   161,   170,   175,   177,   183,
     191,   201,   214,   227,   236,   247,   250,   261,   277,   278,
     279,   280,   281,   339,   347,   357,   358,   365,   372,   383,
     433,   438,   445,   464,   485,   502,   515,   528,   538,   550,
     560,   572,   584,   595
};

// Print the state stack on the debug stream.
void
yy::prologxx_parser::yystack_print_ ()
{
  *yycdebug_ << "Stack now";
  for (state_stack_type::const_iterator i = yystate_stack_.begin ();
       i != yystate_stack_.end (); ++i)
    *yycdebug_ << ' ' << *i;
  *yycdebug_ << std::endl;
}

// Report on the debug stream that the rule \a yyrule is going to be reduced.
void
yy::prologxx_parser::yyreduce_print_ (int yyrule)
{
  unsigned int yylno = yyrline_[yyrule];
  /* Print the symbols being reduced, and their result.  */
  *yycdebug_ << "Reducing stack by rule " << yyn_ - 1
             << " (line " << yylno << "), ";
  for (unsigned char i = yyprhs_[yyn_];
       0 <= yyrhs_[i]; ++i)
    *yycdebug_ << yytname_[yyrhs_[i]] << ' ';
  *yycdebug_ << "-> " << yytname_[yyr1_[yyn_]] << std::endl;
}
#endif // YYDEBUG

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
yy::prologxx_parser::token_number_type
yy::prologxx_parser::yytranslate_ (int token)
{
  static
  const token_number_type
  translate_table[] =
  {
         0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      18,    19,     2,     2,    17,     2,    16,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    25,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    21,     2,    22,     2,    20,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    23,     2,    24,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15
  };
  if ((unsigned int) token <= yyuser_token_number_max_)
    return translate_table[token];
  else
    return yyundef_token_;
}

const int yy::prologxx_parser::yyeof_ = 0;
const int yy::prologxx_parser::yylast_ = 80;
const int yy::prologxx_parser::yynnts_ = 25;
const int yy::prologxx_parser::yyempty_ = -2;
const int yy::prologxx_parser::yyfinal_ = 21;
const int yy::prologxx_parser::yyterror_ = 1;
const int yy::prologxx_parser::yyerrcode_ = 256;
const int yy::prologxx_parser::yyntokens_ = 26;

const unsigned int yy::prologxx_parser::yyuser_token_number_max_ = 270;
const yy::prologxx_parser::token_number_type yy::prologxx_parser::yyundef_token_ = 2;

#line 609 "plparse.y"



void yy::prologxx_parser::error(const yy::prologxx_parser::location_type &l,
			      const std::string &m)
{
   driver.error(l,m);
}
